/usr/bin/clear
echo "--------------------------------------------------------"   >> /var/log/FPGA_LOAD.log
echo "--------------------------------------------------------"   >> /var/log/psm.log
echo "--------------------------------------------------------" 
echo "Date and Time of FPGA installation"                         >> /var/log/FPGA_LOAD.log
echo "Date and Time of FPGA installation"                         >> /var/log/psm.log
echo "Date and Time of FPGA installation" 
echo "--------------------------------------------------------"   >> /var/log/FPGA_LOAD.log
echo "--------------------------------------------------------"   >> /var/log/psm.log
echo "--------------------------------------------------------" 
date | tee -a /var/log/FPGA_LOAD.log /var/log/psm.log
echo "--------------------------------------------------------"   >> /var/log/FPGA_LOAD.log
echo "--------------------------------------------------------"   >> /var/log/psm.log
echo "retreving board details.."                                  >> /var/log/FPGA_LOAD.log
echo "retreving board details.."                                  >> /var/log/psm.log
echo "--------------------------------------------------------"   >> /var/log/FPGA_LOAD.log
echo "--------------------------------------------------------"   >> /var/log/psm.log
echo "U-Boot Env" >> /var/log/FPGA_LOAD.log
echo "U-Boot Env" >> /var/log/psm.log    
echo "=========="  >> /var/log/FPGA_LOAD.log    
echo "=========="  >> /var/log/psm.log
/nn/bin/fw_printenv  >> /var/log/FPGA_LOAD.log  
/nn/bin/fw_printenv  >> /var/log/psm.log
echo "" >> /var/log/FPGA_LOAD.log               
echo "" >> /var/log/psm.log
echo "cpuinfo" >> /var/log/FPGA_LOAD.log        
echo "cpuinfo" >> /var/log/psm.log
echo "=======" >> /var/log/FPGA_LOAD.log        
echo "=======" >> /var/log/psm.log
cat /proc/cpuinfo >> /var/log/FPGA_LOAD.log     
cat /proc/cpuinfo >> /var/log/psm.log
echo "" >> /var/log/FPGA_LOAD.log               
echo "" >> /var/log/psm.log
echo "Kernel Version" >> /var/log/FPGA_LOAD.log 
echo "Kernel Version" >> /var/log/psm.log
cat /proc/version >> /var/log/FPGA_LOAD.log     
cat /proc/version >> /var/log/psm.log

#Trapping (Ignoring Signals)
trap "" 3  #ignoring SIGQUIT 
trap "" 1  #ignoring SIGHUB
trap "" 15 #ignoring SIGTERM
trap "" 9  #ignoring SIGKILL
trap "" 2  #ignoring SIGINT


minor_old=`/nn/bin/psmtest -f | head -n 2 | tail -n 1 |   awk '{print $6}'`
major_old=`/nn/bin/psmtest -f | head -n 1 | awk '{print $6}'`
echo "old major number: $major_old ; old minor number: $minor_old" >> /var/log/FPGA_LOAD.log
echo "old major number: $major_old ; old minor number: $minor_old" >> /var/log/psm.log 
if [ $minor_old -eq 62 -a $major_old -eq 1 ];then
       
	echo " -------------------------------------------------------"
	echo "system has proper FPGA number.. No need to upgrade FPGA.."
	echo "quiting FPGA upgradation process..."
	echo "system has proper FPGA number.. No need to upgrade FPGA.." >> /var/log/FPGA_LOAD.log
	echo "system has proper FPGA number.. No need to upgrade FPGA.." >> /var/log/psm.log
	echo "quiting FPGA upgradation process..." >> /var/log/FPGA_LOAD.log
	echo "quiting FPGA upgradation process..." >> /var/log/psm.log	
	echo "--------------------------------------------------------"
	#Resetting signals
        echo " resetting SIGNALS "
        echo " resetting SIGNALS "  >> /var/log/FPGA_LOAD.log 
		echo " resetting SIGNALS "  >> /var/log/psm.log
        trap -
        #Resetting LEDs
        echo " resetting LEDS "
        echo " resetting LEDS "  >> /var/log/FPGA_LOAD.log
		echo " resetting LEDS "  >> /var/log/psm.log
        /nn/bin/AddNnuDiagLog -v 10909
	exit

else

	echo "starting FPGA upgradation process.. "
	echo "----------------------------------------" 
	echo "----------------------------------------"  >> /var/log/FPGA_LOAD.log 
	echo "----------------------------------------"  >> /var/log/psm.log
	echo -e "\033[47m\033[1;29mThis script to upgrade HWM_FPGA Firmware\033[0m"
	echo "This script to upgrade HWM_FPGA Firmware"  >> /var/log/FPGA_LOAD.log  
	echo "This script to upgrade HWM_FPGA Firmware"  >> /var/log/psm.log
	echo "----------------------------------------"  >> /var/log/FPGA_LOAD.log
	echo "----------------------------------------"  >> /var/log/psm.log
	echo "----------------------------------------" 
	echo -e "\033[47m\033[1;29mThis script to upgrade HWM_FPGA Firmware\033[0m"
	echo "----------------------------------------" 
	if [ -e /nn/images/hwmfpga.dat ]; then 
  		 echo "HWM_FPGA image exist"  >> /var/log/FPGA_LOAD.log
		 echo "HWM_FPGA image exist"  >> /var/log/psm.log
 		 echo "checking the size of hwmfpga.dat"  >> /var/log/FPGA_LOAD.log
		 echo "checking the size of hwmfpga.dat"  >> /var/log/psm.log
   		 size=`ls -l /nn/images/hwmfpga.dat | awk '{print $5}'`
   		 if [ $size -eq 259189 ]; then
			echo "size of hwmfpga.dat matched"
			echo "size of hwmfpga.dat matched"  >> /var/log/FPGA_LOAD.log 
			echo "size of hwmfpga.dat matched"  >> /var/log/psm.log
		 else
			echo "size of hwmfpga.dat did not match, stopping the script"
			echo "size of hwmfpga.dat did not match, stopping the script"  >> /var/log/FPGA_LOAD.log
			echo "size of hwmfpga.dat did not match, stopping the script"  >> /var/log/psm.log
			#Resetting signals
			trap -
			#Resetting LEDs
			/nn/bin/AddNnuDiagLog -v 10909
			exit
   		fi
		permission=`ls -l /nn/images/hwmfpga.dat | awk '{print $1}'`
   		if [ "$permission" == "-rwxr--r--" ]; then
			echo "hwmfpga.dat has executable permission"
			echo "hwmfpga.dat has executable permission"  >> /var/log/FPGA_LOAD.log
			echo "hwmfpga.dat has executable permission"  >> /var/log/psm.log
		else
			echo "hwmfpga.dat does not have executable permission"
			echo "hwmfpga.dat does not have executable permission"  >> /var/log/FPGA_LOAD.log 
			echo "hwmfpga.dat does not have executable permission"  >> /var/log/psm.log
			echo "changing the permission" 
			echo "changing the permission"  >> /var/log/FPGA_LOAD.log
			echo "changing the permission"  >> /var/log/psm.log
			chmod +x /nn/images/hwmfpga.dat
   		fi
   
    		if [ -e /nn/bin/dptop ]; then
			echo "dptop exists" 
               		 echo "dptop exists"  >> /var/log/FPGA_LOAD.log
					 echo "dptop exists"  >> /var/log/psm.log
        	else
			echo "dptop does not exists"
                	echo "dptop does not exists" >> /var/log/FPGA_LOAD.log
					echo "dptop does not exists" >> /var/log/psm.log
                	#Resetting signals
               		 trap -
                	#Resetting LEDs
               		 /nn/bin/AddNnuDiagLog -v 10909
               		 exit
        	fi

      		size_dptop=`ls -l /nn/bin/dptop | awk '{print $5}'`

        	if [ $size_dptop -eq 39240 ]; then
			echo "size of dptop matched"
               		 echo "size of dptop matched"  >> /var/log/FPGA_LOAD.log
					 echo "size of dptop matched"  >> /var/log/psm.log
        	else
			echo" size of dptop did not match, stopping the script"
                	echo" size of dptop did not match, stopping the script"  >> /var/log/FPGA_LOAD.log
					echo" size of dptop did not match, stopping the script"  >> /var/log/psm.log
                	#Resetting signals
                	trap -
                	#Resetting LEDs
                	/nn/bin/AddNnuDiagLog -v 10909
                	exit
        	fi

         	permission_dptop=`ls -l /nn/bin/dptop | awk '{print $1}'`
         	if [ "$permission_dptop" == "-rwxr-xr-x" ]; then
			echo "has executable permission"
                	echo "has executable permission"  >> /var/log/FPGA_LOAD.log
					echo "has executable permission"  >> /var/log/psm.log
                else
  			echo "does not have executable permission" 
                	echo "does not have executable permission"  >> /var/log/FPGA_LOAD.log
					echo "does not have executable permission"  >> /var/log/psm.log
			echo "changing the permission" 
                	echo "changing the permission"  >> /var/log/FPGA_LOAD.log      
					echo "changing the permission"  >> /var/log/psm.log
                	chmod +x /nn/bin/dptop
         	fi
   		echo "stopping PSM" 
   		echo "stopping PSM"  >> /var/log/FPGA_LOAD.log   
		echo "stopping PSM"  >> /var/log/psm.log
   		/nn/bin/processcontrol stop psm > /dev/null
   		if [ $? -eq 0 ]; then
       			echo "PSM Stopped" 
       			echo "PSM Stopped"  		>> /var/log/FPGA_LOAD.log 
				echo "PSM Stopped"          >> /var/log/psm.log
       			echo "loading Jtag module"
       			echo "loading Jtag module"  	>> /var/log/FPGA_LOAD.log 
				echo "loading Jtag module"      >> /var/log/psm.log
       			/sbin/insmod /nn/lib/modules/nn_jtag.o > /dev/null
       			echo "----------------------------------------"  		>> /var/log/FPGA_LOAD.log  
				echo "----------------------------------------"         >> /var/log/psm.log
       			echo "Upgrading HWM_FPGA Firmware"  	>> /var/log/FPGA_LOAD.log  
				echo "Upgrading HWM_FPGA Firmware"  	>> /var/log/psm.log
       			echo "Please don't interrupt"  		>> /var/log/FPGA_LOAD.log  
				echo "Please don't interrupt"  		>> /var/log/psm.log
       			echo "it may take about 4 minutes to complete"  >> /var/log/FPGA_LOAD.log 
				echo "it may take about 4 minutes to complete"  >> /var/log/psm.log
       			echo "----------------------------------------"  		     >> /var/log/FPGA_LOAD.log 
				echo "----------------------------------------"  		     >> /var/log/psm.log
	
	 		echo "----------------------------------------" 
	 		echo -e "\033[5;31mUpgrading HWM_FPGA Firmware \033[0m" 
         		echo -e "\033[5;31mPlease don't interrupt \033[0m"
	 		echo -e "\033[5;31mit may take about 4 minutes to complete \033[0m"
			echo "----------------------------------------"

       			/nn/bin/dptop > /dev/null
       			if [ $? -eq 0 ]; then 
           		echo "HWM_FPGA upgrade complete"  		    >> /var/log/FPGA_LOAD.log 
				echo "HWM_FPGA upgrade complete"  		    >> /var/log/psm.log
	  		echo -e "\033[32mHWM_FPGA upgrade complete \033[0m"
	   		echo "----------------------------------------" 
           		echo "----------------------------------------"  		    >> /var/log/FPGA_LOAD.log 
				echo "----------------------------------------"  		    >> /var/log/psm.log
	   		echo "removing Jtag module" 
           		echo "removing Jtag module"  					    >> /var/log/FPGA_LOAD.log  
				echo "removing Jtag module"  					    >> /var/log/psm.log 
           		/sbin/rmmod nn_jtag
        		else
				echo "dptop failed"
				echo "dptop failed"  					    >> /var/log/FPGA_LOAD.log  
				echo "dptop failed"  					    >> /var/log/psm.log
			fi
   		else
       			echo "Unable to stop psm" 
       			echo "Unable to stop psm"  					    >> /var/log/FPGA_LOAD.log  
				echo "Unable to stop psm"  					    >> /var/log/psm.log
   		fi
	else
   		echo "HWM_FPGA image is not exist on /nn/images"  		            >> /var/log/FPGA_LOAD.log  
		echo "HWM_FPGA image is not exist on /nn/images"  		            >> /var/log/psm.log
   		echo "HWM_FPGA image is not exist on /nn/images" 
	fi
	echo "----------------------------------------"
	echo "----------------------------------------"  				    >> /var/log/FPGA_LOAD.log  
	echo "----------------------------------------"  				    >> /var/log/psm.log
	#Resetting signals
	echo "resetting SIGNALS "  
	echo "resetting SIGNALS "  							    >> /var/log/FPGA_LOAD.log  
	echo "resetting SIGNALS "  							    >> /var/log/psm.log 
	trap -
	#Resetting LEDs
	echo "resetting LEDS "  
	echo "resetting LEDS "  >> /var/log/FPGA_LOAD.log  >> /var/log/psm.log
	echo "resetting LEDS "  >> /var/log/psm.log
	/nn/bin/AddNnuDiagLog -v 10909
	minor_new=`/nn/bin/psmtest -f | head -n 2 | tail -n 1 |   awk '{print $6}'`
	major_new=`/nn/bin/psmtest -f | head -n 1 | awk '{print $6}'`
	count=0
	while [ $minor_new -ne 62 -a $major_new -ne 1 -a $count -le 4  ]
	do
		sleep 30
		minor_new=`/nn/bin/psmtest -f | head -n 2 | tail -n 1 |   awk '{print $6}'`
		major_new=`/nn/bin/psmtest -f | head -n 1 | awk '{print $6}'`
		(( count++ ))
	done

	echo "new major number: $major_new ; new minor number: $minor_new" | tee -a /var/log/FPGA_LOAD.log /var/log/psm.log
	
	if [ $minor_new -eq 62 -a $major_new -eq 1 ];then
		
		echo "success"
		echo "success"  >> /var/log/FPGA_LOAD.log 
		echo "success"  >> /var/log/psm.log
		sleep 30
		reboot
	else
		echo "upgrade error... not rebooting"
		echo "upgrade error... not rebooting" >> /var/log/FPGA_LOAD.log 
		echo "upgrade error... not rebooting" >> /var/log/psm.log
	fi
	
fi
